<?php
/*---------------------------------------------------------

    IvVݒʃNX

---------------------------------------------------------*/
class GTOGM_Setting {
	
	private $gtogm_info;
	
	//
	//  RXgN^
	//
	function __construct() {
		
		// vOCǗCX^X
		$this->gtogm_info = new GTOGM_Info();
		
		add_action("admin_menu", array(&$this, "add_config_page"));
		
	}
	
	//
	//  
	//
	function add_config_page() {
		
		// Ǘʂ̃j[ɁAvOC̐ݒʗpj[ǉ
		$plugin_page = add_options_page( $this->gtogm_info->get_plugin_name(), $this->gtogm_info->get_plugin_name(), 10, basename(__FILE__), array(&$this, "config_page") );
		
		// ǉǗʂ̃wb_[ɃR[hǉ
		add_action('admin_head-' . $plugin_page, array(&$this, 'add_css'));
		
	}
	
	//
	//
	//
	function add_css() {
		echo '<style type="text/css">' . "\n";
		echo 'table#icontable {' . "\n";
		echo '    ' . "\n";
		echo '}' . "\n";
		echo 'table#icontable td {' . "\n";
		echo '    vertical-align: middle;' . "\n";
		echo '    text-align: left;' . "\n";
		echo '    padding: 0;' . "\n";
		echo '    margin: 0;' . "\n";
		echo '    height: 32px;' . "\n";
		echo '}' . "\n";
		echo 'table#icontable td.icon {' . "\n";
		echo '    text-align: center;' . "\n";
		echo '}' . "\n";
		echo '</style>' . "\n";
	}
	
	//
	//  ʐyуIvVlۑ
	//
	function config_page(){
		
		// GTOGM_InfoNX̒萔擾  print <<< Œ萔gpłȂߕϐɊi[
		$G_NORMAL_MAP       = GTOGM_Info::G_NORMAL_MAP;
		$G_SATELLITE_MAP    = GTOGM_Info::G_SATELLITE_MAP;
		$G_HYBRID_MAP       = GTOGM_Info::G_HYBRID_MAP;
		$G_PHYSICAL_MAP     = GTOGM_Info::G_PHYSICAL_MAP;
		$G_SATELLITE_3D_MAP = GTOGM_Info::G_SATELLITE_3D_MAP;
		
		$LARGE_MAP_CONTROL    = GTOGM_Info::LARGE_MAP_CONTROL;
		$MAP_TYPE_CONTROL     = GTOGM_Info::MAP_TYPE_CONTROL;
		$OVERVIEW_MAP_CONTROL = GTOGM_Info::OVERVIEW_MAP_CONTROL;
		$SCALE_CONTROL        = GTOGM_Info::SCALE_CONTROL;
		
		if($_SERVER["REQUEST_METHOD"] == "POST"){
			
			// F
			if (! wp_verify_nonce($_REQUEST["_wpnonce"], plugin_basename(__FILE__)) )
				return false;
			
			// `FbN
			if (!current_user_can("manage_options"))
				return false;
			
			check_admin_referer(plugin_basename(__FILE__));
			
			// [U͒l擾
			// text
			$google_maps_api_key  = $_POST["google_maps_api_key"];
			$line_color           = $_POST["line_color"];
			$line_weight          = $_POST["line_weight"];
			$line_opacity         = $_POST["line_opacity"];
			$map_width            = $_POST["map_width"];
			$map_height           = $_POST["map_height"];
			$label_color          = $_POST["label_color"];
			$icon_url             = $_POST["icon_url"];
			// radio
			$map_type             = $_POST["map_type"];
			$icon                 = $_POST["icon"];
			// select
			$zoom_level           = (int) $_POST["zoom_level"];
			// checkbox array
			if (isset($_POST["control"])) { 
				$control          = $_POST["control"];
			} else {
				$control          = array();
			}
			if (isset($_POST["map_type_control"])) {
				$map_type_control = $_POST["map_type_control"];
			} else {
				$map_type_control = array();
			}
			// checkbox single
			if (isset($_POST["kashmir"])) {
				$kashmir          = (int) $_POST["kashmir"];
			} else {
				$kashmir          = 0;
			}
			if (isset($_POST["open_google_maps"])) {
				$open_google_maps = (int) $_POST["open_google_maps"];
			} else {
				$open_google_maps = 0;
			}
			
			// IvVlۑ
			$this->gtogm_info->set_option("google_maps_api_key", $google_maps_api_key);
			$this->gtogm_info->set_option("line_color", $line_color);
			$this->gtogm_info->set_option("line_weight", $line_weight);
			$this->gtogm_info->set_option("line_opacity", $line_opacity);
			$this->gtogm_info->set_option("map_width", $map_width);
			$this->gtogm_info->set_option("map_height", $map_height);
			$this->gtogm_info->set_option("label_color", $label_color);
			$this->gtogm_info->set_option("icon_url", $icon_url);
			$this->gtogm_info->set_option("map_type", $map_type);
			$this->gtogm_info->set_option("icon", $icon);
			$this->gtogm_info->set_option("zoom_level", $zoom_level);
			$this->gtogm_info->set_option("control", $control);
			$this->gtogm_info->set_option("map_type_control", $map_type_control);
			$this->gtogm_info->set_option("kashmir", $kashmir);
			$this->gtogm_info->set_option("open_google_maps", $open_google_maps);
		}
		
		// IvVl擾
		$google_maps_api_key   = $this->gtogm_info->get_option("google_maps_api_key");
		$line_color            = $this->gtogm_info->get_option("line_color");
		$line_weight           = $this->gtogm_info->get_option("line_weight");
		$line_opacity          = $this->gtogm_info->get_option("line_opacity");
		$map_width             = $this->gtogm_info->get_option("map_width");
		$map_height            = $this->gtogm_info->get_option("map_height");
		$label_color           = $this->gtogm_info->get_option("label_color");
		$icon_url              = $this->gtogm_info->get_option("icon_url");
		$map_type              = $this->gtogm_info->get_option("map_type");
		$icon                  = $this->gtogm_info->get_option("icon");
		$zoom_level            = $this->gtogm_info->get_option("zoom_level");
		$control               = $this->gtogm_info->get_option("control");
		$map_type_control      = $this->gtogm_info->get_option("map_type_control");
		$kashmir               = $this->gtogm_info->get_option("kashmir");
		$open_google_maps      = $this->gtogm_info->get_option("open_google_maps");
		
		// WI{^ n}^Cv
		$map_type_checked = array();
		if ($map_type == $G_NORMAL_MAP) {
			$map_type_checked[$G_NORMAL_MAP] = "checked=\"checked\"";
		} else if ($map_type == $G_SATELLITE_MAP) {
			$map_type_checked[$G_SATELLITE_MAP] = "checked=\"checked\"";
		} else if ($map_type == $G_HYBRID_MAP) {
			$map_type_checked[$G_HYBRID_MAP] = "checked=\"checked\"";
		} else if ($map_type == $G_PHYSICAL_MAP) {
			$map_type_checked[$G_PHYSICAL_MAP] = "checked=\"checked\"";
		} else if ($map_type == $G_SATELLITE_3D_MAP) {
			$map_type_checked[$G_SATELLITE_3D_MAP] = "checked=\"checked\"";
		}
		
		// `FbN{bNX  Rg[
		if (is_array($control)) {
			foreach ($control as $value) {
				$control_checked[$value] = "checked=\"checked\"";
			}
		}
		
		// `FbN{bNX  n}^Cv؂ւ{^
		if (is_array($map_type_control)) {
			foreach ($map_type_control as $value) {
				$map_type_control_checked[$value] = "checked=\"checked\"";
			}
		}
		
		// `FbN{bNX  JV~[3DD
		if ($kashmir == 1) {
			$kashmir_checked = "checked=\"checked\"";
		}
		
		// `FbN{bNX  GoogleMapsJN
		if ($open_google_maps == 1) {
			$open_google_maps_checked = "checked=\"checked\"";
		}
		
		// \LZbg
		$option_page_title = $this->gtogm_info->get_plugin_name();
		
		$message_google_maps_api = __("Google Maps API Key:", "gtogm");
		$message_map_type = __("Map Type:", "gtogm");
		$message_map_size = __("Map Size:", "gtogm");
		$message_control_display = __("Control Display:", "gtogm");
		$message_line_style = __("Line Style:", "gtogm");
		$message_link_display = __("Link Display", "gtogm");
		
		$message_normal_map = __("Normal", "gtogm");
		$message_satellite_map = __("Satellite", "gtogm");
		$message_hybrid_map = __("Hybrid", "gtogm");
		$message_physical_map = __("Physical", "gtogm");
		$message_satellite_3d_map = __("Satellite 3D", "gtogm");
		
		$message_width = __("Width:", "gtogm");
		$message_height = __("Height:", "gtogm");
		$message_pixel = __("pixel", "gtogm");
		
		$message_overview_map_control = __("Overview Map Control", "gtogm");
		$message_map_type_control = __("Map Type Control", "gtogm");
		$message_large_map_control = __("Map Control", "gtogm");
		$message_scale_control = __("Scale Control", "gtogm");
		
		$message_color = __("Color:", "gtogm");
		$message_weight = __("Weight:", "gtogm");
		$message_opacity = __("Opacity:", "gtogm");
		$message_precedence_kashmir = __("Precedence kashmir3D", "gtogm");
		$message_only_kashmir = __("(Only Color and Weight. Only GPX made in kashmir-3D.)", "gtogm");
		
		$message_open_google_maps = __("Open Google Maps", "gtogm");
		
		$message_zoom_level = __("Zoom Level:", "gtogm");
		$zoom_level_option_auto = __("Auto", "gtogm");
		
		$message_label_color = __("Label Color", "gtogm");
		
		$message_icon_url = __("Icon", "gtogm");
		
		$message_save_settings = __("Save Changes", "gtogm");
		
		$wpnonce = wp_nonce_field(plugin_basename(__FILE__), "_wpnonce", true, false);
		
		
		// Y[x<option>쐬
		$zoom_level_options = '<option value="-1">' . $zoom_level_option_auto . '</option>';
		for ($i=0;$i<=19;$i++) {
			if ($zoom_level == $i) {
				$zoom_level_options .= '<option value="' . $i . '" selected>' . $i . '</option>';
			} else {
				$zoom_level_options .= '<option value="' . $i . '">' . $i . '</option>';
			}
		}
		
		$icons = array();
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/blue-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/red-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/green-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/ltblue-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/yellow-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/purple-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/pink-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/orange-dot.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/blue.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/red.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/green.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/lightblue.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/yellow.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/purple.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/pink.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/orange.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/blue-pushpin.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/red-pushpin.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/grn-pushpin.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/ltblu-pushpin.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/ylw-pushpin.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/purple-pushpin.png";
		$icons[] = "http://maps.google.co.jp/mapfiles/ms/icons/pink-pushpin.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_green.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_red.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_blue.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_orange.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_purple.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_yellow.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_gray.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_black.png";
		$icons[] = "http://labs.google.com/ridefinder/images/mm_20_white.png";
//		$icons[] = "http://maps.google.com/mapfiles/kml/paddle/1_maps.png";
//		$icons[] = "http://maps.google.com/mapfiles/kml/paddle/A_maps.png";
//		$icons[] = "http://www.google.com/mapfiles/gadget/letters/markerA.png";
//		$icons[] = "http://www.google.com/mapfiles/gadget/arrowSmall80.png";
		$icons[] = "";
		
		$icon_spans = '<table id="icontable">';
		for ($i=0;$i<count($icons);$i++) {
			$icon_spans .= '<tr>';
			if ($icon == $icons[$i]) {
				$icon_checked = 'checked="checked"';
			} else {
				$icon_checked = '';
			}
			if ($icons[$i] == "") {
				$icon_spans .= '<td class="radio"><input type="radio" name="icon" id="icon' . ($i + 1) . '" class="icon" value="" ' . $icon_checked . ' /></td><td class="icon">URL</td><td class="url"><input type="text" name="icon_url" id="icon_url" class="regular-text" value="' . $icon_url . '" /></td>';
			} else {
				$icon_spans .= '<td class="radio"><input type="radio" name="icon" id="icon' . ($i + 1) . '" class="icon" value="' . $icons[$i] . '" ' . $icon_checked . ' /></td><td class="icon"><img src="' . $icons[$i] . '" /></td><td class="url">' . $icons[$i] . '</td>';
			}
			$icon_spans .= '</tr>';
		}
		$icon_spans .= "</table>";
		
print <<< EOF
		<div class="wrap">
			<h2>{$option_page_title}</h2>
			<form action="" method="post" id="gtogm_plugin-config">
				{$wpnonce}
				<table class="form-table">
					<tr>
						<th scope="row" valign="top">{$message_google_maps_api}</th>
						<td><input type="text" name="google_maps_api_key" id="google_maps_api_key" class="regular-text" value="{$google_maps_api_key}"/></td>
					</tr>
					<tr>
						<th scope="row" valign="top">{$message_map_size}</th>
						<td>
							<label for="map_width">{$message_width}</label><input type="text" name="map_width" id="map_width" class="small-text" value="{$map_width}"/>{$message_pixel}<br />
							<label for="map_height">{$message_height}</label><input type="text" name="map_height" id="map_height" class="small-text" value="{$map_height}" />{$message_pixel}
						</td>
					</tr>
					<tr>
						<th scope="row" valign="top">{$message_zoom_level}</th>
						<td>
							<select name="zoom_level">
								{$zoom_level_options}
							</select>
						</td>
					</tr>
					<tr>
						<th scope="row" valign="top">{$message_map_type}</th>
						<td>
							<input type="radio" name="map_type" id="map_type" value="{$G_NORMAL_MAP}"       {$map_type_checked[$G_NORMAL_MAP]}       />{$message_normal_map}<br />
							<input type="radio" name="map_type" id="map_type" value="{$G_SATELLITE_MAP}"    {$map_type_checked[$G_SATELLITE_MAP]}    />{$message_satellite_map}<br />
							<input type="radio" name="map_type" id="map_type" value="{$G_HYBRID_MAP}"       {$map_type_checked[$G_HYBRID_MAP]}       />{$message_hybrid_map}<br />
							<input type="radio" name="map_type" id="map_type" value="{$G_PHYSICAL_MAP}"     {$map_type_checked[$G_PHYSICAL_MAP]}     />{$message_physical_map}<br />
							<input type="radio" name="map_type" id="map_type" value="{$G_SATELLITE_3D_MAP}" {$map_type_checked[$G_SATELLITE_3D_MAP]} />{$message_satellite_3d_map}
						</td>
					</tr>
					<tr>
						<th scope="row" valign="top">{$message_control_display}</th>
						<td>
							<input type="checkbox" name="control[]" id="overview_map_control" value="{$OVERVIEW_MAP_CONTROL}" {$control_checked[$OVERVIEW_MAP_CONTROL]} />{$message_overview_map_control}<br />
							<input type="checkbox" name="control[]" id="map_type_control"     value="{$MAP_TYPE_CONTROL}"     {$control_checked[$MAP_TYPE_CONTROL]}     />{$message_map_type_control}<br />
							<input type="checkbox" name="control[]" id="large_map_control"    value="{$LARGE_MAP_CONTROL}"    {$control_checked[$LARGE_MAP_CONTROL]}    />{$message_large_map_control}<br />
							<input type="checkbox" name="control[]" id="scale_control"        value="{$SCALE_CONTROL}"        {$control_checked[$SCALE_CONTROL]}        />{$message_scale_control}
						</td>
					</tr>
					<tr>
						<th scope="row" valign="top">{$message_map_type_control}</th>
						<td>
							<input type="checkbox" name="map_type_control[]" id="g_normal_map"       value="{$G_NORMAL_MAP}"       {$map_type_control_checked[$G_NORMAL_MAP]}       />{$message_normal_map}<br />
							<input type="checkbox" name="map_type_control[]" id="g_satellite_map"    value="{$G_SATELLITE_MAP}"    {$map_type_control_checked[$G_SATELLITE_MAP]}    />{$message_satellite_map}<br />
							<input type="checkbox" name="map_type_control[]" id="g_hybrid_map"       value="{$G_HYBRID_MAP}"       {$map_type_control_checked[$G_HYBRID_MAP]}       />{$message_hybrid_map}<br />
							<input type="checkbox" name="map_type_control[]" id="g_physical_map"     value="{$G_PHYSICAL_MAP}"     {$map_type_control_checked[$G_PHYSICAL_MAP]}     />{$message_physical_map}<br />
							<input type="checkbox" name="map_type_control[]" id="g_satellite_3d_map" value="{$G_SATELLITE_3D_MAP}" {$map_type_control_checked[$G_SATELLITE_3D_MAP]} />{$message_satellite_3d_map}
						</td>
					</tr>
					<tr>
						<th scope="row" valign="top">{$message_link_display}</th>
						<td>
							<input type="checkbox" name="open_google_maps" id="open_google_maps" value="1" {$open_google_maps_checked} />{$message_open_google_maps}<br />
						</td>
					</tr>
					<tr>
						<th scope="row" valign="top">{$message_line_style}</th>
						<td>
							<label for="line_color">{$message_color}</label><input type="text" name="line_color" id="line_color" class="small-text" value="{$line_color}" /> 000000 - ffffff<br />
							<label for="line_weight">{$message_weight}</label><input type="text" name="line_weight" id="line_weight" class="small-text" value="{$line_weight}" /> 1 - 10<br />
							<label for="line_opacity">{$message_opacity}</label><input type="text" name="line_opacity" id="line_opacity" class="small-text" value="{$line_opacity}" /> 0 - 255<br />
							<label for="kashmir"><input type="checkbox" name="kashmir" id="kashmir" value="1" {$kashmir_checked} />{$message_precedence_kashmir} {$message_only_kashmir}
						</td>
					</tr>
EOF;
//					<tr>
//						<th>{$message_label_color}</th>
//						<td>
//							<label for="label_color">{$message_color}</label><input type="text" name="label_color" id="label_color" class="small-text" value="{$label_color}" /> 000000 - ffffff
//						</td>
//					</tr>
print <<< EOF
					<tr>
						<th>{$message_icon_url}</th>
						<td>
							{$icon_spans}
						</td>
					</tr>
				</table>
				<br/>
				<span class="submit" style="border: 0;"><input type="submit" name="submit" class="button-primary" value="{$message_save_settings}" /></span>
			</form>
		</div>
EOF;

	}
}
?>